function varargout = SOLEXSYFIT(varargin)
% SOLEXSYFIT MATLAB code for SOLEXSYFIT.fig
%      SOLEXSYFIT, by itself, creates a new SOLEXSYFIT or raises the existing
%      singleton*.
%
%      H = SOLEXSYFIT returns the handle to a new SOLEXSYFIT or the handle to
%      the existing singleton*.
%
%      SOLEXSYFIT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SOLEXSYFIT.M with the given input arguments.
%
%      SOLEXSYFIT('Property','Value',...) creates a new SOLEXSYFIT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before SOLEXSYFIT_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to SOLEXSYFIT_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help SOLEXSYFIT

% Last Modified by GUIDE v2.5 02-Apr-2014 10:57:52

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @SOLEXSYFIT_OpeningFcn, ...
                   'gui_OutputFcn',  @SOLEXSYFIT_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before SOLEXSYFIT is made visible.
function SOLEXSYFIT_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to SOLEXSYFIT (see VARARGIN)

% Choose default command line output for SOLEXSYFIT
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes SOLEXSYFIT wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = SOLEXSYFIT_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
















% --- Executes on button press in Load_DNfile.
function Load_DNfile_Callback(hObject, eventdata, handles)
% hObject    handle to Load_DNfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global DNref Nres mxTimesDN DresNum;

[filename, path] = uigetfile('*.txt; *.dat; *.tab; *.csv','Select your Deutoron file');
fullpath = [path filename];   
DNref = parseSparkyDecayList(fullpath)
mxTimesDN = getMixingtimes(fullpath)

[a b] = size(DNref);          %-------count the number of residues
DresNum = a;
set(handles.Num_ResD,'String',DresNum);


set(handles.valid_c,'String','LOADED');
set(handles.Load_DNfile,'Enable','off');
 







% --- Executes on button press in Load_HNfile.
function Load_HNfile_Callback(hObject, eventdata, handles)
% hObject    handle to Load_HNfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global DNref HNref Nres mxTimesHN labelD DresNum;

[filename, path] = uigetfile('*.txt; *.dat; *.tab; *.csv','Select your Proton file');
fullpath = [path filename];   
HNref=parseSparkyDecayList(fullpath)
mxTimesHN = getMixingtimes(fullpath)

[a b] = size(HNref);          %-------count the number of residues
HresNum = a;
set(handles.Num_ResH,'String',HresNum);


% Call temp by asking the larger of res # btwn Deutoron and Proton files
if HresNum > DresNum
    temp = HresNum;
else
    temp = DresNum;
end


% Report the Residues position where mismatch occurs
for i=1:temp
    if DNref(i,1) ==  HNref(i,1)
            set(handles.valid_d,'String','LOADED');
            set(handles.mismatch_res,'String','NA');
            [aa bb] = size(HNref);
            Nres= aa;
    elseif DresNum < HresNum
            set(handles.mismatch_res,'String',num2str(HNref(i,1)));
            set(handles.valid_d,'String','ERROR');
            set(handles.Load_initguess,'Enable','off');
            set(handles.Go,'Enable','off');
            break
    elseif DresNum > HresNum
            set(handles.mismatch_res,'String',num2str(DNref(i,1)));
            set(handles.valid_d,'String','ERROR');
            set(handles.Load_initguess,'Enable','off');
            set(handles.Go,'Enable','off');
            break
    end
end

labelD = strcat('Res # ',  num2str(HNref(1:a,1),'%02d')       ) ;
set(handles.Load_HNfile,'Enable','off');
    









% --- Executes on button press in Load_initguess.
function Load_initguess_Callback(hObject, eventdata, handles)
% hObject    handle to Load_initguess (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global init_guess Nres;

RandomGuessGenerator  = zeros(Nres,7);

xmin=0.5; xmax=5;               % set boundary for intial guess for k1H k2D R1H R1D to be between 0.5 and 5
xxmin=0.8; xxmax= 1.5;          % set boundary for intial guess for a0H and a0Dop to be between 0.8 and 1.5
xxxmin=0.01; xxxmax= 0.1;       % set boundary for intial guess for filter leakage err to be between 0.01 and 0.1

for i=1:Nres
    for j=1:4
        RandomGuessGenerator(i,j) = xmin+rand*(xmax-xmin);
    end
    
    for k=5:6
        RandomGuessGenerator(i,k) = xxmin+rand*(xxmax-xxmin);    
    end
        RandomGuessGenerator(i,7) = xxxmin+rand*(xxxmax-xxxmin); 
end

init_guess = RandomGuessGenerator


% Set button to etheir LOADED or ERROR
set(handles.Load_initguess,'Enable','off');

if Nres >= 1
    set(handles.valid_a,'String','LOADED');
else
    set(handles.valid_a,'String','ERROR');
end











% --- Executes on button press in Go.
function Go_Callback(hObject, eventdata, handles)

global tmix                                             % H/D exchange time in the experiments, in seconds
global exptl_diag_pk          exptl_cross_pk	        % experimental N(H) and N(D) peaks respectivelly, relative values, as generated by NMRpipe during integration
global calc_diag_pk           calc_cross_pk             % obtained by simulations N(H) and N(D) peaks respectivelly
global tmix_plot                                        % array of H/D exchange times used for plotting
global calc_diag_pk_plot      calc_cross_pk_plot        % N(H) and N(D) peaks calculated for given times tmix_plot for plotting
global err2 err2n                                       % errors
global noise_diag_pk          noise_cross_pk            % N(H) and N(D) peaks from synthetic spectra generated to obtain error bars
global calc_diag_noise        calc_cross_noise          % calculated N(H) and N(D) during optimizations made on synthetic spectra
global init_guess DNref HNref labelD Nres mxTimesDN mxTimesHN






Nmc = str2num(get(handles.txtNumMC,'String'))           % import # of MC simulations (number of noise added spectra)
SpcNoise = str2num(get(handles.txtNoise,'String'))      % import Spectral noise from Proton files

if length(Nmc)<1
    msgbox('Please enter a valid # of Monte Carlo simulation.','Message','warn');
end

if length(SpcNoise)<1
    msgbox('Please enter a valid # for Spectral Noise.','Message','warn');
end

if and( length(Nmc) >= 1 , length(SpcNoise) >= 1 )
    % show the waitbar at 0 %
    h = waitbar(0,'Please wait while processing ...');
end




perc_cut=0.159;       % ---------WHAT IS THIS FOR --------???????????





%  ----------Check parsing and sorting DN and HN files before proceed
if DNref(:,1) == HNref(:,1)
    set(handles.fitstatus,'String',['Parsing & sorting residues agreed']);
else
    set(handles.fitstatus,'String',['ERROR: Mis-matched Residues between DN and HN files ! ABORT !']);
    return
end

%  -------------Again check Mixing times before proceed
if mxTimesDN == mxTimesHN  
    tmix= mxTimesDN   % import agreed mxTimes from both DN and HN , unit in seconds
else
    set(handles.fitstatus,'String',['ERROR: Mis-matched mxTimes between DN and HN files ! ABORT !']);
    return
end

b = length(tmix);   %  b is # mixing times performed









fid4=fopen('./fit_genout35error.dat','w');     % only rates and rms
fprintf(fid4,'res\tk1H\tk1Hav\tk1std\tk2D\tk2Dav\tk2std\tR1H\tR1Hav\tR1Hstd\tR1D\tR1Dav\tR1Dstd\ta0H\ta0Hav\ta0Hstd\ta0D\ta0Dav\ta0Dstd\tb0D\tb0Dav\tb0Dstd\t');
fprintf(fid4,'errk1\terr\t\n');
 

% ---------------- START WRITING output files ------------------------


   fid3=fopen('./fit_genout35ref.dat','w');     % only rates and rms
   fprintf(fid3,'res\tk1H\tk2D\tR1H\tR1D\ta0H\ta0D\tb0D\terr\n');

   fid2=fopen('./fit_dataout35ref.dat','w');    % only exper. and fitted data
   fprintf(fid2,'times');
   fprintf(fid2,'\t');
   fprintf(fid2,'%4.3f\t%4.3f\t%4.3f\t%4.3f\t%4.3f\t%4.3f\t%4.3f\t%4.3f\t%4.3f\n\n',tmix);
   fprintf(fid2,'\n');

set(handles.fitstatus,'String','DO  NOT  INTERUPT ! ANALYSIS  IN  PROCESS !');










   
%------------------------- beginnig of the fitting cycle-------------------
for j=1:Nres                                       % residue counter

    fprintf('residue N=');
    fprintf('%d\n',j);
  
    exptl_diag_pk   = HNref(j,2:b+1)'                   % extracting experimental N(H) intensities only, ignore index col
    exptl_cross_pkA = DNref(j,2:b+1)'                   % extracting experimental N(D) intensities only, ignore index col

    
    
    
    % ----------- start to reorder N(D) values----------- WHY ?????????????
    % ------ Reordering is not needed when using SPARKY ----- VHL 4-23-2014
    for kk = 1:b
        exptl_cross_pkB(kk) = exptl_cross_pkA(kk) ;    
    end
    exptl_cross_pk = exptl_cross_pkB'                
    % ------ Reordering is not needed when using SPARKY ----- VHL 4-23-2014

    
    
   

    nrmref = HNref(j,2)                               % use 0 mxTime value of H_peak (largest value) for normalization constant
    exptl_diag_pk   =  double(exptl_diag_pk)  ./ double(nrmref)
    exptl_cross_pk  =  double(exptl_cross_pk) ./ double(nrmref)
    
    
    

    % --- FIT ASSUMING THAT EXCHANGE HAPPENS ONLY DURING TMIX ---

    k1_0 = init_guess(j,1);
    k2_0 = k1_0 / 1.1;                                    % 1.1 fractionation factor, plus gain from relaxation
    R1_Nz_H_0=init_guess(j,3);		
    R1_Nz_D_0=init_guess(j,4);                            % importing guesses from initial guess file. GOOD HERE 4-2-14 VHL
    
    amp_0_NH = init_guess(j,5);
    amp_0_ND = init_guess(j,6); 		   
    b0_0_NH = 0;
    b0_0_ND = 0; 
    
    x0=[  k1_0,  k2_0,  R1_Nz_H_0,  R1_Nz_D_0,  amp_0_NH,  amp_0_ND,  b0_0_ND  ];    % x0 simply is all starting initial guess for everything
    
    
    
    minopt = optimset('TolX',1e-6,'TolFun',1e-6,'MaxFunEvals',1e6,'MaxIter',1e6);    %   optimiation conditions
    x  =   fminsearch('chi2_simple35',x0, minopt);                  % call chi2_simple35 function for fitting the data at residues j

    expD = double(exptl_cross_pk) .* double(nrmref)                 % now return the real value before divided by normalization constant
    expH =  double(exptl_diag_pk) .* double(nrmref)                 % now return the real value before divided by normalization constant
    
    calcD = double(calc_cross_pk) .* double(nrmref)                 % output from chi2_simple35 fitting fuction again scale with normalization const
    calcH = double(calc_diag_pk) .* double(nrmref)                  % output from chi2_simple35 fitting fuction again scale with normalization const
    
    
       
    % ----------------Writing to output files here -------------

    fprintf(fid3, labelD(j,:) );
    fprintf(fid3, '\t' );
    fprintf(fid3,'%5.3f\t%5.3f\t%4.3f\t%4.3f\t%4.3f\t%4.3f\t%4.3f\t%4.3f\t%4.3f\t%4.3f\n', x(1), x(1)/1.1, abs(x(3)), abs(x(4)), x(5), x(6), x(7), err2 );  
    fprintf(fid3, '\n' ); 

    fprintf(fid2,labelD(j,:)); 
    fprintf( fid2, '\t' );
    fprintf(fid2,'%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\n',expD);
    fprintf(fid2,'\n');
    fprintf(fid2,labelD(j,:),'H'); 
    fprintf(fid2, '\t' );
    fprintf(fid2,'%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\n',expH);
    fprintf(fid2,'\n');
    fprintf( fid2,labelD(j,:) );
    fprintf( fid2,'sim\t' );
    fprintf(fid2,'%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\n',calcD);
    fprintf(fid2,'\n');
    fprintf( fid2,labelD(j,:) );
    fprintf( fid2,'sim\t' );
    fprintf(fid2,'%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\t%4.3e\n',calcH);
    fprintf(fid2,'\n');
    fprintf('\n');

    
    
    
    
    
         
         
        
    %---------------------- BEGIN MonteCarlo approach (MC)-----------------
    
    DN = ones(Nres,b+1);
    DN(:,1) = DNref(:,1);
    HN = ones(Nres,b+1);
    HN(:,1) = HNref(:,1);
    
     
    for MCindex = 1:Nmc;
        
        
        fprintf('\nCurrent Monte Carlo position:    ')
        if MCindex>1
            for z=0:log10(MCindex-1)
              fprintf('\b'); % delete previous counter display
            end
        end
        fprintf('%d', MCindex);
        pause(1); % allows time for display to update
        fprintf('\n')

        
        
        
                        
        %--------------------create noise file for Deutoron----------------
        for rowD = 1:Nres
            for colD = 2:b+1              % 1 st column in indexing, intensity data is from 2 to b+1 column from line 265
        
                plus_minus_NoiseD = -SpcNoise + (SpcNoise + SpcNoise).*rand;    % generate a random between neg and pos value of Spectral noise
                DN(rowD,colD) = DNref(rowD,colD) + plus_minus_NoiseD;
                                
            end
        end
        DN;                                  % export DN to test noise data set
        
        %--------------------create noise file for Proton------------------
        for rowH = 1:Nres
            for colH = 2:b+1                                  % 1 st column in indexing, intensity data is from 2 to b+1 column from line 265
        
                plus_minus_NoiseH = -SpcNoise + (SpcNoise + SpcNoise).*rand;    % generate a random between neg and pos value of Spectral noise
                HN(rowH,colH) = HNref(rowH,colH) + plus_minus_NoiseH;
                                
            end
        end
        HN;                                  % export HN to test noise data set
              
        noise_cross_pkA  = DN(j,2:b+1)';                      % 1 st column in indexing, intensity data is from 2 to b+1 column from line 265
        noise_diag_pk    = HN(j,2:b+1)';                      % 1 st column in indexing, intensity data is from 2 to b+1 column from line 265
        
        
        %   ----again reverse the order of deteuton peaks  -------WHY ?????
        % ------ Reordering is not needed when using SPARKY ----- VHL 4-23-2014
        for kkk=1:b
            noise_cross_pkB(kkk) = noise_cross_pkA(kkk) ;
        end
        noise_cross_pk = noise_cross_pkB';
        % ------ Reordering is not needed when using SPARKY ----- VHL 4-23-2014


        
        nrm = HN(j,2);                                        % noise spectra scalling factor from Proton intensity at first mxTime
    
        noise_diag_pk   =   noise_diag_pk   /   nrm;          % divide % H noise scalling factor
        noise_cross_pk  =   noise_cross_pk  /   nrm;          % divide % D noise scalling factor
    
        
        HNinput(:,MCindex)  =   noise_diag_pk   *   nrm;      % return HN before normalization
        DNinput(:,MCindex)  =   noise_cross_pk  *   nrm;      % return DN before normalization
        
        
        
        % feed the current MC file at MCindex to optimization to obtain error bars       
        xmc = fminsearch('chi2_simple35noise',x0, minopt);     % optimization for all res at file # Monte Carlo
        xmc_array(MCindex,:) = xmc;
        
                        
    end; 
    
    % -------------------------- END of Monte Carlo optimization ----------
    
    
    
            
    mean_x   = mean(xmc_array);                                 % calculate the Mean for plotting  
    sigma_x  = std(xmc_array);                                  % calculate the Std Deviation for plotting  

    sigma_HN = std(HNinput,0,2);
    sigma_DN = std(DNinput,0,2);

    
    % ------ fid4  writting output to   fit_genout35error.dat  ------------
    fprintf(fid4, labelD(j,:) );            
    fprintf(fid4, '\t' );
    fprintf(fid4,'%4.3f\t%4.3f\t%4.3f\t', x(1),mean_x(1), sigma_x(1));
    fprintf(fid4,'%4.3f\t%4.3f\t%4.3f\t', x(1)/1.1,mean_x(1)/1.1, sigma_x(1)/1.1);
    fprintf(fid4,'%4.3f\t%4.3f\t%4.3f\t', abs(x(3)),abs(mean_x(3)), abs(sigma_x(3)));
    fprintf(fid4,'%4.3f\t%4.3f\t%4.3f\t', abs(x(4)),abs(mean_x(4)), abs(sigma_x(4)));
    fprintf(fid4,'%4.3f\t%4.3f\t%4.3f\t', x(5),mean_x(5), sigma_x(5));
    fprintf(fid4,'%4.3f\t%4.3f\t%4.3f\t', x(6),mean_x(6), sigma_x(6));
    fprintf(fid4,'%4.3f\t%4.3f\t%4.3f\t', x(7),mean_x(7), sigma_x(7));
    fprintf(fid4, '%5.3f\t%5.3f\t\n', err2*x(1), err2 );  
    
    
    
    %------------ PLOTTING begins HERE---------------------
    
    figure(1);
    errorbar(tmix , exptl_diag_pk,  double(sigma_HN) / double(nrmref) , double(sigma_HN) / double(nrmref) ,'ro');
    hold on
    errorbar(tmix , exptl_cross_pk , double(sigma_DN) / double(nrmref) , double(sigma_DN) / double(nrmref),'bo');

    tmix_plot = linspace(min(tmix),max(tmix),200);               % x-axis is tmix from smallest (left) to largest values (right)
    chi2_simple_plot35(x);                                       % call on     chi2_simple_plot35     function to do the plotting

    plot(tmix_plot , calc_diag_pk_plot , 'g-');                      % fit green line goes through all data point for Proton data
    plot(tmix_plot , calc_cross_pk_plot , 'g-');                     % fit green line goes through all data point for Deutoron data
    hold off

    nam = deblank(labelD(j,:));
    graph_name = ['  err=', num2str(err2),  ' ',  nam ];
    title(graph_name);
    
    
    % -------- Exporting graph, Prefered format is EPS -----------
    fn0 = ['v35plot_',nam,'.eps'];
    print( gcf, '-depsc2', fn0 )

    hold off
    fprintf('\n');
    
    %close all
    
    waitbar(j/Nres,h);

end;

% close all fid writers
fclose(fid3);
fclose(fid2);
fclose(fid4);

%close the waitbar
close(h);










function Num_ResD_Callback(hObject, eventdata, handles)
% hObject    handle to Num_ResD (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Num_ResD as text
%        str2double(get(hObject,'String')) returns contents of Num_ResD as a double


% --- Executes during object creation, after setting all properties.
function Num_ResD_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Num_ResD (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function loop_status_Callback(hObject, eventdata, handles)
% hObject    handle to loop_status (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of loop_status as text
%        str2double(get(hObject,'String')) returns contents of loop_status as a double


% --- Executes during object creation, after setting all properties.
function loop_status_CreateFcn(hObject, eventdata, handles)
% hObject    handle to loop_status (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function no_res_Callback(hObject, eventdata, handles)
% hObject    handle to no_res (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of no_res as text
%        str2double(get(hObject,'String')) returns contents of no_res as a double


% --- Executes during object creation, after setting all properties.
function no_res_CreateFcn(hObject, eventdata, handles)
% hObject    handle to no_res (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Loadautofit.
function Loadautofit_Callback(hObject, eventdata, handles)
% hObject    handle to Loadautofit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function aboutmenu_Callback(hObject, eventdata, handles)
% hObject    handle to aboutmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
aboutBox();



function Num_ResH_Callback(hObject, eventdata, handles)
% hObject    handle to Num_ResH (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Num_ResH as text
%        str2double(get(hObject,'String')) returns contents of Num_ResH as a double


% --- Executes during object creation, after setting all properties.
function Num_ResH_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Num_ResH (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mismatch_res_Callback(hObject, eventdata, handles)
% hObject    handle to mismatch_res (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mismatch_res as text
%        str2double(get(hObject,'String')) returns contents of mismatch_res as a double


% --- Executes during object creation, after setting all properties.
function mismatch_res_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mismatch_res (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txtNoise_Callback(hObject, eventdata, handles)
% hObject    handle to txtNoise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtNoise as text
%        str2double(get(hObject,'String')) returns contents of txtNoise as a double


% --- Executes during object creation, after setting all properties.
function txtNoise_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtNoise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txtNumMC_Callback(hObject, eventdata, handles)
% hObject    handle to txtNumMC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtNumMC as text
%        str2double(get(hObject,'String')) returns contents of txtNumMC as a double


% --- Executes during object creation, after setting all properties.
function txtNumMC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtNumMC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
